<?php

/*
* FothoFax - A Simple FiloFax replacement
* Copyright (C) 2005 Tom Fotherby
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


//////////////////////////////////////////////////////////////////////////
///////////  C o n f i g u r a t i o n    V a r i a b l e s //////////////
///////////     M U S T     B E     C O N F I G U R E D     //////////////
//////////////////////////////////////////////////////////////////////////

  // 11111111111111111111111111111111111111111111111111111111
  // Set this to the location of your address book data file:
  $bdayFile = 'AddressBook.txt';

  // 22222222222222222222222222222222222222222222222222222222
  // Set this to the location of your calendar data file:
  $eventFile = 'EventsBook.txt';

  //333333333333333333333333333333333333333333333333333333333
  // Set this to the date of the anniversary you want to be reminded of
  $anniversary     = '3/2/1999'; //Format: mon/day/year
  $anniversaryText = 'Kix and me started going out';
  $anniDayReminder = 100; //Only set if you want an additional reminder every x days. :-)

//////////////////////////////////////////////////////////////////////////
///////////  C o n f i g u r a t i o n    V a r i a b l e s //////////////
///////////                  O P T I O N A L                //////////////
//////////////////////////////////////////////////////////////////////////

  // Set this to the relative path of the FothoFaxImages directory (should be correct by default)
  $imagesFile = 'FothoFaxImages';

  // Only set this if you want users to be able to edit the birthday file (e.g. if it is an a wikiwiki page).
  $bdayFileEditURL = "<a href=\'../../../../../myPublicWiki/moin.cgi/AddressBook?action=edit\'><img border=0 src=\'$imagesFile/editBdays.gif\'>(Edit People)</a>"; 

  // Only set this if you want users to be able to edit the Events file (e.g. if it is an a wikiwiki page).
  $eventFileEditURL = "<a href=\'../../../../../myPublicWiki/moin.cgi/EventsBook?action=edit\'><img border=0 src=\'$imagesFile/editEvents.gif\'>(Edit Events)</a>"; 

  $version = "0.31 (May 2006)";

//////////////////////////////////////////////////////////////////////////
///////  D a t a     G a t h e r i n g     F u n c t i o n s  ////////////
///////        N O    E D I T I N G     N E E D E D           ////////////
//////////////////////////////////////////////////////////////////////////

  //Gather all birthdays in an array:
  $bdayArry = gatherBdays($bdayFile);
  //print_r($bdayArry);

  //Gather all deathdays in an array:
  $ddayArry = gatherDdays();
  //print_r($ddayArry);

  //Gather all events in an array:
  $evntArry = gatherEvents($eventFile);
  //print_r($evntArry);

  //Gather anniversary data:
  if ($anniversary != "")
  {
    $date_MonthDayYear = explode("/",$anniversary);
    $anniMonth = $date_MonthDayYear[1];
    $anniDay   = $date_MonthDayYear[0];
    $anniYear  = $date_MonthDayYear[2];
    $anniversary_julianDay = gregoriantojd($anniMonth,$anniDay,$anniYear);
  }

//////////////////////////////////////////////////////////////////////////
// This reads in a file formatted in a particular way and outputs an array of birthdays
function gatherBdays($bdayFile)
{
 $bdayLastSeen = "";   //birthday var
 $ddayLastSeen = "";   //deathday var
 $currentName = "";
 $nameLastSeen = "";

 $fileLines = file($bdayFile);

 foreach ($fileLines as $line_num => $line) {

  if (preg_match("/^\s+\*\sName\:\s([\w \-]+)/",$line,$matches)) {
    $nameLastSeen = chop($matches[1]);  //chop removes trailing whitespace.
  }

  if (preg_match("/^\s+\*\sBirthday\:/",$line,$matches)) {
    if (preg_match("/^\s+\*\sBirthday\:\s([\d\w\/]+)/",$line,$matches)) {
      $bdayLastSeen = $matches[1];      // $bdayLastSeen will be in the format: "20/Mar/1980".

      // Check date format
      if (!preg_match("/^\d\d\/\w\w\w\/\d\d\d\d$/",$bdayLastSeen,$matches)) {
	print "FotherFax Problem! <b><font color=\"red\">Unknown date format</font></b> for birthday. Valid date format is \"DD/MMM/YYYY\". Please correct \"$bdayFile\" and re-load page. The line causing the problem is \"$line\".\n";
	$bdayLastSeen = "";
      }
    }
  }

  if (preg_match("/^\s+\*\sDeathday\:\s([\d\w\/]+)/",$line,$matches)) {
    $ddayLastSeen = $matches[1];      // $ddayLastSeen will be in the format: "20/Mar/1980".

      // Check date format
      if (!preg_match("/^\d\d\/\w\w\w\/\d\d\d\d$/",$ddayLastSeen,$matches)) {
	print "FotherFax Problem! <b><font color=\"red\">Unknown date format</font></b> for deathday. Valid date format is \"DD/MMM/YYYY\". Please correct \"$bdayFile\" and re-load page. The line causing the problem is \"$line\".\n";
	$bdayLastSeen = "";
      }
  }

  //After going through one name and getting to the next, print out relevant info
  if ($nameLastSeen != $currentName || $line_num == sizeof($fileLines)-1) {

    if ($bdayLastSeen != "") {
      $pplArray["$currentName"] = array("Name" => $currentName,
                                        "Bday" => $bdayLastSeen,
                                        "Age"  => strlen($bdayLastSeen) > 6 ? (Date("Y") - substr($bdayLastSeen,7,4)) : "?");

      if ($ddayLastSeen != "")
      	$pplArray["$currentName"]["Dday"] = $ddayLastSeen; //Add a deathday for this person

      $bdayArry[substr($bdayLastSeen,0,6)][] = $pplArray["$currentName"];
    }

    $currentName = $nameLastSeen;
    $bdayLastSeen = "";
    $ddayLastSeen = "";
  }
 }
  return $bdayArry;
}

//////////////////////////////////////////////////////////////////////////
// This creates an array of deathDays given an array of people information
function gatherDdays()
{
 global $bdayArry;

 foreach ($bdayArry as $personArray) {
  foreach ($personArray as $person) {
   if ($person["Dday"] != "")
      $oDdayArray[substr($person["Dday"],0,6)][] = $person;
  }
 }
 return $oDdayArray;
}

//////////////////////////////////////////////////////////////////////////
// This reads in a file formatted in a particular way and outputs an array of events
// This is an example of the return array:
//  $evntArry["20/Mar/80"][0] = "Tom going for birthday meal";
//  $evntArry["20/Mar/80"][1] = "Tom opening birthday presents";
//  $evntArry["26/Mar/80"][0] = "Mothers day;
//  ...
function gatherEvents($eventFile)
{
 $dateLastSeen = "";

 $fileLines = file($eventFile);

 foreach ($fileLines as $line_num => $line) {

  if (preg_match("/^\s+\*\sDate\:\s([\d\w\/]+)/",$line,$matches)) {
    $foundDate = $matches[1];
    if (preg_match("/^(\d\d\/\w\w\w\/\d\d)$/",$foundDate,$dateCheck)) {
      $dateLastSeen = $dateCheck[1];
    } else if (preg_match("/^(\d\d\/\w\w\w)$/",$foundDate,$dateCheck1)) {
      // Event doesn't have year so add current year.
      $dateLastSeen = $dateCheck1[1] . '/' . strftime("%y");
    } else {
      print "FotherFax Problem! <b><font color=\"red\">Unknown date format</font></b> for event: \"$foundDate\". Valid date format is \"DD/MMM\" or \"DD/MMM/YY\". Please correct \"$eventFile\" and re-load page.\n";
      exit;
    }
  }

  //After going through one event and getting to the next, print out relevant info
  if (preg_match("/^\s+\*\sEvent\:\s(.*)/",$line,$matches)) {
    $event = $matches[1];
    $eventDay   = substr($dateLastSeen,0,2);
    $eventMonth = substr($dateLastSeen,3,3);
    $eventYear  = substr($dateLastSeen,7,2);

    $evntArry["$eventDay/$eventMonth/$eventYear"][] = $event;
  }
 }
  return $evntArry;
}


?>
